#ifndef __MOZILLAREADER_H
#define __MOZILLAREADER_H

#include	"Bookmark.h"
#include	"HTMLtag.h"

#include	"Logger.h"
#include	"IbookmarkTree.h"

#undef EXTERN
#ifdef ISMOZILLAREADER
#define EXTERN
#else
#define EXTERN extern
#endif

// HTML͏
struct parseStatus {
	char previous;	/* 1O̕ */
	int inTag;	/* ^O̒ǂH */
	int inComment;	/* RgǂH */
	int isUtf8;	/* UTF-8ǂH */
	int inDD;	/* DDGgǂH */
	int storeing;	/* vf̒gi[邩ǂH */
	char itemType;	/* vf̌` */
	int folderLevel;	/* tH_̊Kw */
	int ignore;	/* ݃tH_𖳎Ă邩ǂ */
	int ignoreLevel;	/* ĂtH_̊Kw */
};

class MozillaReader {
private:
	char noIEfavorites;	// 1:IÊCɓRo[gȂB 0:
	IbookmarkTree *writer;	// ݗpIuWFNg
	int isSilentMode;	// 1:t@CI[vsbZ[WȂ 0:

// ꎞobt@
	char *scFile,*work;
	char item[BUFLEN],*pItem;	// H3̒gۑ
	int cItem;				// item̕JEgp
	Bookmark bookmark;
	int f_item;
	int m_bookmarkNo;	// ǂݍłubN}[N̔ԍ
	char *urlBuf;	// URLϊpobt@
	int urlBufLen;	// URLϊpobt@TCY
	Logger *logger;

	int reallocUrlBuf(int size);
	int flushItem(int type,struct parseStatus *stat);
	int checkAnchorTag(HTMLtag *tag);
	int parseAElement(struct parseStatus *stat,HTMLtag *tag);
	int checkFolderTag(HTMLtag *tag);
	int parseH3Element(struct parseStatus *stat,HTMLtag *tag);
	int parseDlElement(struct parseStatus *stat,HTMLtag *tag);
	int parseDdEnd(struct parseStatus *stat,HTMLtag *tag);
	int parseDdElement(struct parseStatus *stat,HTMLtag *tag);
	int parseMetaElement(struct parseStatus *stat,HTMLtag *tag);
	int checkHrTag(HTMLtag *tag);
	int parseHrElement(struct parseStatus *stat,HTMLtag *tag);
	int parseElement(struct parseStatus *stat,HTMLtag *tag);
	int parseHTML(struct parseStatus *stat,HTMLtag *tag,char c);
	void initParseStatus(struct parseStatus *stat);
	int readFile(const char *bmFile,const char *fvDir);
	void trimLastSpaceOnly(char *buf);

public:
	char setIEfavoritesImport(char mode){	noIEfavorites = mode;return mode;}
	void setBookmarkWriter(IbookmarkTree *obj){	writer = obj; }
	MozillaReader();
	~MozillaReader();
	int readBookmark(const char *bmFile,const char *fvDir);
	void setSilentMode(int mode){	isSilentMode = mode;}
	int getBookmarkNo(void) { return m_bookmarkNo; }
	void setBookmarkNo(int no){	m_bookmarkNo = no;}
	void setLogger(Logger *loggerObj) {
		logger = loggerObj;
	}

};

#undef EXTERN

#endif
